#include <stddef.h>
#include <stdlib.h>

#include <suplib/str.h>

#include "lua_register.h"



void
register_list( lua_State *L, const char* module, luaL_Reg* fptr[], bool intrinsic )
{
    char *mods;
    size_t nfunc = 0;
    luaL_Reg** ptr = fptr;
    luaL_Reg* func;
    luaL_Reg* funcp;

    /* count functions */

    while( *ptr) ptr++;

    nfunc = ptr - fptr;
    func = funcp = (luaL_Reg*) malloc( ( nfunc + 1 ) * sizeof(luaL_Reg) );

    while ( nfunc-- )
	*funcp++ = **fptr++;

    (*funcp).name = NULL;
    (*funcp).func = NULL;

    mods = str_join( ".", 2, intrinsic ? "saotrace.raygen.intrinsic" : "saotrace.raygen", module );

    luaL_register( L, mods, func );
    free( mods );
    free( func );
}


void
register_list( lua_State *L, const char* module, luaL_Reg func[], bool intrinsic )
{
    char *mods;

    mods = str_join( ".", 2, intrinsic ? "saotrace.raygen.intrinsic" : "saotrace.raygen", module );

    luaL_register( L, mods, func );
    free( mods );
}
