#include <string>
#include <iostream>

#include <lua.hpp>
#include <lauxlib.h>


#include "gtest/gtest.h"

#include "config.h"
#include "lua_interface.h"
#include "lua_stack.h"

using namespace std;


class VersionTest : public testing::Test {

protected:

    lua_State *L;

    virtual void SetUp() {

	L = init_lua("", "");
    }

    virtual void TearDown() {

	cleanup_lua( L );

    }
};



TEST_F( VersionTest, config ) {

    int err = get_luaglobal( L, "saotrace.raygen", "version" );
    ASSERT_EQ( 0, err ) << "saotrace.raygen.version not found";

    err = lua_pcall( L, 0, 1, 0 );
    ASSERT_EQ( 0, err ) << lua_tostring(L, -1 );

    cerr << lua_tostring(L, -1 ) << endl;

    EXPECT_STREQ( VERSION, lua_tostring(L, -1 ) );
}

